Imports System.Data
Imports System.Data.OleDb

Public Class frmGestinClientes
    Dim cn As New OleDbConnection
    Dim daClientes As OleDbDataAdapter
    Dim daPedidos As OleDbDataAdapter
    Dim daProductos As OleDbDataAdapter
    Dim ds As New DataSet
    Dim nombreBBDD = Application.StartupPath & "\Ejemplo.mdb"


    Private Sub frmGestinClientes_Load(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles MyBase.Load
        ConfigurarAccesoADatos()
        'Enlazar DataGridView a la tabla Clientes
        DataGridView1.DataSource = ds
        DataGridView1.DataMember = "Clientes"

        'Si queremos que algunas columnas no se vean se puede utilizar:
        'DataGridView1.Columns("NombreColumna").Visible = False
        '
        'Tambin se puede cambiar la cabecera de una columna con:
        'DataGridView1.Columns("NombreColumna").HeaderText = "NuevoNombreColumna"
        DataGridView1.Columns("IdCliente").HeaderText = "ID.Cliente"
        DataGridView1.Columns("CP").HeaderText = "Cdigo Postal"
        'Para ajustar el ancho de las columnas
        DataGridView1.AutoResizeColumns()

        ''Recorre todas las celdas de un DataGridView
        ''Recorre todas las filas
        'For i As Integer = 0 To DataGridView1.Rows.Count - 1
        '    'Recorre todas las columnas de la fila
        '    For j As Integer = 0 To DataGridView1.Columns.Count - 1
        '        'Accede a cada una de las celdas j,i
        '        Debug.Write(DataGridView1(j, i).Value & " ")
        '    Next
        '    Debug.WriteLine("")
        'Next

    End Sub

    Private Sub ConfigurarAccesoADatos()
        'Abre la conexin, establece el adaptador de datos y rellena el Dataset

        'Abrir la conexin
        cn.ConnectionString = "PROVIDER=Microsoft.jet.oledb.4.0;Data Source=" & nombreBBDD
        cn.Open()

        'Configurar los adaptadores de datos
        daClientes = New OleDbDataAdapter("SELECT * FROM Clientes", cn)
        daPedidos = New OleDbDataAdapter("SELECT * FROM Pedidos", cn)
        daProductos = New OleDbDataAdapter("SELECT * FROM Productos", cn)

        'Cargar el dataset
        daClientes.Fill(ds, "Clientes")
        daPedidos.Fill(ds, "Pedidos")
        daProductos.Fill(ds, "Productos")

        'Cerrar la conexin
        cn.Close()


    End Sub

    Private Sub btnSalir_Click(ByVal sender As System.Object, _
                    ByVal e As System.EventArgs) Handles btnSalir.Click
        Me.Dispose()
    End Sub

    'Este evento se produce al hacer doble Click sobre una celda de DataGridView
    Private Sub DataGridView1_CellContentDoubleClick(ByVal sender As Object, _
                            ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) _
                            Handles DataGridView1.CellContentDoubleClick
        'Rellenar los cuadros de texto del formulario frmDetallesCliente
        'con la informacin del cliente de la celda seleccionada
        'La orden Width, permite abreviar la referencia al objeto
        With My.Forms.frmDetallesCliente
            .txtIdCliente.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("IdCliente")
            .txtApellidos.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("Apellidos")
            .txtNombre.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("Nombre")
            .txtPoblacin.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("Ciudad")
            .txtProvincia.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("Provincia")
            .txtCP.Text = _
               ds.Tables("Clientes").Rows(e.RowIndex).Item("CP")
        End With
        'Establecer los pedidos del cliente a partir de una vista de la tabla Pedidos
        Dim dv As DataView = ds.Tables("Pedidos").DefaultView
        dv.Sort = "Fecha"
        dv.RowFilter = "IdCliente =" & _
             ds.Tables("Clientes").Rows(e.RowIndex).Item("IdCliente")
        My.Forms.frmDetallesCliente.DataGridView1.AutoResizeColumns()
        My.Forms.frmDetallesCliente.DataGridView1.DataSource = dv
        My.Forms.frmDetallesCliente.DataGridView1.AutoSizeColumnsMode = _
              DataGridViewAutoSizeColumnsMode.AllCells
        'Mostrar el formulario secundario
        My.Forms.frmDetallesCliente.Show()

    End Sub
End Class
